import nltk, re, pprint

sentence = "This is the time -- and this is the record of the time."
words = sentence.split()
len(words)

len(set(words))

words[2]

words[2] == words[8]

words[2] is words[8]

words[2] is words[2]

set(words)

from StringIO import StringIO
def fake_open(filename, mode=None):
    return StringIO('Hello World!\nThis is a test file.\n')
def fake_urlopen(url):
    return StringIO('<!doctype html public "-//W3C//DTD HTML 4.0 Transitional//EN"')
open = fake_open
import urllib
urllib.urlopen = fake_urlopen

f = open('corpus.txt', 'rU')

f = open('corpus.txt', 'rU')

import os
os.listdir('.')

f.read() 

text = open('corpus.txt', 'rU').read()

f = open('corpus.txt', 'rU')
for line in f:
    print line[:-1]

from urllib import urlopen
page = urlopen("http://news.bbc.co.uk/").read()
print page[:60]

line = '<title>BBC NEWS | News Front Page</title>'
new = re.sub(r'<.*>', '', line)

new

page = re.sub('<.*?>', '', page)
page = re.sub('\s+', ' ', page)
print page[:60]

nltk.corpus.gutenberg.files()

for book in nltk.corpus.gutenberg.files():
    print book + ':', len(nltk.corpus.gutenberg.words(book))

nltk.corpus.brown.categories()

nltk.corpus.brown.words(categories='a')

nltk.corpus.brown.sents(categories='a')

print nltk.corpus.nps_chat.words()

nltk.corpus.cess_esp.words()

nltk.corpus.floresta.words()

nltk.corpus.udhr.words('Javanese-Latin1')[11:]

nltk.corpus.indian.words('hindi.pos')

import pylab
for president, texts in speeches()[-7:]:
    growth = list(vocab_growth(texts))[:10000]
    pylab.plot(growth, label=president, linewidth=2)
pylab.title('Vocabulary Growth in State-of-the-Union Addresses')
pylab.legend(loc='lower right')
pylab.show()         # doctest: +SKIP

text = '''Hello.  Isn't this fun?'''
pattern = r'\w+|[^\w\s]+'
nltk.tokenize.regexp_tokenize(text, pattern)

text = 'That poster costs $22.40.'
pattern = r'''(?x)
    \w+               # sequences of 'word' characters
  | \$?\d+(\.\d+)?    # currency amounts, e.g. $12.50
  | ([A-Z]\.)+        # abbreviations, e.g. U.S.A.
  | [^\w\s]+          # sequences of punctuation
'''
nltk.tokenize.regexp_tokenize(text, pattern)

nltk.tokenize.regexp_tokenize(text, pattern=r'\s+', gaps=True)

stemmer = nltk.PorterStemmer()
verbs = ['appears', 'appear', 'appeared', 'calling', 'called']
stems = []
for verb in verbs:
    stemmed_verb = stemmer.stem(verb)
    stems.append(stemmed_verb)
sorted(set(stems))

str = 'This is the time'
str.lower()

sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
[word.lower() for word in sent]

[stemmer.stem(verb) for verb in verbs]

set(stemmer.stem(verb) for verb in verbs)

def is_lexical(word):
    return word.lower() not in ('a', 'an', 'the', 'that', 'to')
[word for word in sent if is_lexical(word)]

[word.lower() for word in sent if is_lexical(word)]

sent = nltk.corpus.brown.sents(categories='a')[0]
[(x, stemmer.stem(x).lower()) for x in sent]

len(nltk.corpus.brown.words()) / len(nltk.corpus.brown.sents())

sent_tokenizer=nltk.data.load('tokenizers/punkt/english.pickle')
text = nltk.corpus.gutenberg.raw('chesterton-thursday.txt')
sents = sent_tokenizer.tokenize(text)
pprint(sents[171:181])

sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
result = []
for word in sent:
    word_len = (word, len(word))
    result.append(word_len)
result

words = ['attribution', 'confabulation', 'elocution',
         'sequoia', 'tenacious', 'unidirectional']
vsequences = set()
for word in words:
    vowels = []
    for char in word:
        if char in 'aeiou':
            vowels.append(char)
    vsequences.add(''.join(vowels))
sorted(vsequences)

counts = nltk.defaultdict(int)           # [_count-initialization]
sec_a = nltk.corpus.brown.words(categories='a')
for token in sec_a:
    counts[token] += 1                   # [_count-increment]
for token in sorted(counts)[:5]:         # [_count-output]
    print counts[token], token

fd = nltk.FreqDist(sec_a)
for token in sorted(fd)[:5]:
    print fd[token], token

from operator import itemgetter
sorted_word_counts = sorted(fd.items(), key=itemgetter(1), reverse=True)  # [_sorted-args]
[token for (token, freq) in sorted_word_counts[:20]]

print_freq(nltk.corpus.brown.words(categories='a'), 20)

plural('fairy')

plural('woman')

names = ['Elinor', 'Marianne', 'Edward', 'Willoughby']
text = nltk.corpus.gutenberg.words('austen-sense.txt')
nltk.draw.dispersion_plot(text, names)

def print_length_dist(text):
    fd = nltk.FreqDist(len(token) for token in text if re.match(r'\w+$', token))
    for i in range(1,15):
        print "%2d" % int(100*fd.freq(i)),
    print

print_length_dist(nltk.corpus.genesis.words('english-kjv.txt'))

print_length_dist(nltk.corpus.genesis.words('finnish.txt'))

langs = ['Chickasaw-Latin1', 'English-Latin1',
         'German_Deutsch-Latin1', 'Greenlandic_Inuktikut-Latin1',
         'Hungarian_Magyar-Latin1', 'Ibibio_Efik-Latin1']
dists = [pylab.plot(cld(l), label=l[:-7], linewidth=2) for l in langs]
pylab.title('Cumulative Word Length Distributions for Several Languages')
pylab.legend(loc='lower right')
pylab.show()     # doctest: +SKIP

model = train_model(nltk.corpus.genesis.words('english-kjv.txt'))
model['living']

list(model['living'])

generate_model(model, 'living')

for file in nltk.corpus.webtext.files():
    words = [word.lower() for word in nltk.corpus.webtext.words(file) if len(word) > 2]
    print file, [w1+' '+w2 for w1, w2 in collocations(words)[:15]]

ignored_words = nltk.corpus.stopwords.words('english')

from nltk import wordnet
car = wordnet.N['motorcar']
car

len(car)

car[0]

list(car[0])

car[0].gloss

poly = wordnet.N['pupil']
for synset in poly:
    print synset

poly[1].gloss

for concept in car[0][wordnet.HYPONYM][:10]:
	print concept

car[0][wordnet.HYPERNYM]

pprint.pprint(wordnet.N['car'][0].tree(wordnet.HYPERNYM))

animals = wordnet.N['animal'][0].closure(wordnet.HYPONYM, depth=4)
[word for synset in animals for word in synset if word in wordnet.V]

wordnet.N['poodle'][0].path_similarity(wordnet.N['dalmatian'][1])

wordnet.N['dog'][0].path_similarity(wordnet.N['cat'][0])

wordnet.V['run'][0].path_similarity(wordnet.V['walk'][0])

wordnet.V['run'][0].path_similarity(wordnet.V['think'][0])

